Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /sml/trunk/config/install.sh
ViewVC logotype

Diff of /sml/trunk/config/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 537, Fri Feb 18 17:20:16 2000 UTC revision 828, Fri May 11 18:32:07 2001 UTC
# Line 9  Line 9 
9  # by M.Blume (2/2000).  # by M.Blume (2/2000).
10  #  #
11    
12    this=$0
13    
14  #  #
15  # get the target list  # get the target list
16  #  #
17  if [ ! -r config/targets ]; then  if [ ! -r config/targets ]; then
18      echo "!!! File config/targets is missing."      echo "$this: !!! File config/targets is missing."
19      exit 1      exit 1
20  fi  fi
21  . config/targets  . config/targets
# Line 22  Line 24 
24  # create the preloads.standard file  # create the preloads.standard file
25  #  #
26  if [ ! -r config/preloads ]; then  if [ ! -r config/preloads ]; then
27      echo "!!! File config/preloads is missing."      echo "$this: !!! File config/preloads is missing."
28      exit 1      exit 1
29  fi  fi
30  cp config/preloads preloads.standard  cp config/preloads preloads.standard
# Line 34  Line 36 
36  MAKE=make  MAKE=make
37    
38  SHELL=/bin/sh  SHELL=/bin/sh
39  echo Using shell $SHELL.  echo $this: Using shell $SHELL.
40    
41  #  #
42  # set the SML root directory  # set the SML root directory
43  #  #
44  REAL_PWD=`pwd`  REAL_PWD=`pwd`
45  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
46  echo SML root is $ROOT.  echo $this: SML root is $ROOT.
47  echo Installation directory is ${INSTALLDIR:=$ROOT}.  echo $this: Installation directory is ${INSTALLDIR:=$ROOT}.
48    
49  #  #
50  # set the various directory and file pathname variables  # set the various directory and file pathname variables
# Line 54  Line 56 
56  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
57  LIBDIR=$INSTALLDIR/lib          # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
58  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
59    LATESTANDALONES=$ROOT/latestandalones # standalone programs to be built late
60  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
61  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
62    
63    URLGETTER=unknown
64    
65  #  #
66  # the path to the dir where ml-yacc, ml-burg, ml-lex, and ml-build live  # the path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and
67    # ml-makedepend live
68  #  #
69  TOOLDIR=$BINDIR  TOOLDIR=$BINDIR
70    
71  #  #
72    # A temporary file for post-editing the pathconfig file...
73    #
74    PCEDITTMP=$INSTALLDIR/pcedittmp.$$
75    
76    #
77    # files to be deleted after we are done...
78    #
79    tmpfiles=""
80    tmpfiles="$tmpfiles $ROOT/preloads.standard"
81    tmpfiles="$tmpfiles $LIBLIST"
82    tmpfiles="$tmpfiles $LATESTANDALONES"
83    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
84    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
85    tmpfiles="$tmpfiles $PCEDITTMP"
86    #
87    # make sure we always clean up after ourselves...
88    #
89    trap 'rm -f $tmpfiles' 0 1 2 3 15
90    
91    
92    #
93  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
94  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
95  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG_DEFAULT.
# Line 74  Line 101 
101  # the release version that we are installing  # the release version that we are installing
102  #  #
103  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
104  echo Installing version $VERSION.  echo $this: Installing version $VERSION.
105    
106    #
107    # the URL for the (usually remote) source archive
108    #
109    SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
110    echo $this: URL of source archive is $SRCARCHIVEURL.
111    
112  #  #
113  # Function to make a directory (and advertise such action).  # Function to make a directory (and advertise such action).
114  #  #
115  makedir() {  makedir() {
116      if [ ! -d $1 ] ; then      if [ ! -d $1 ] ; then
117          echo Making directory $1          echo $this: Making directory $1
118          if mkdir $1 ; then          if mkdir $1 ; then
119              : everything is fine              : everything is fine
120          else          else
121              echo "!!! Unable to make directory $1!"              echo "$this: !!! Unable to make directory $1!"
122                exit 1
123            fi
124        fi
125    }
126    
127    #
128    # Function for asking user to fetch source archive.
129    #   $1 - descriptive name
130    #   $2 - base name without extension, without version, and without dir
131    #   $3 - remote directory
132    #
133    askurl() {
134        echo "$this: Please, fetch $1 archive"
135        echo ' ('$2.'*' or $VERSION-$2.'*)'
136        echo " from $3"
137        echo " and then re-run this script!"
138              exit 1              exit 1
139    }
140    
141    #
142    # Function for fetching source archives automatically using wget or lynx.
143    #   $1 - command to actually get the stuff
144    #   $2 - descriptive name
145    #   $3 - base name without extension and without dir
146    #   $4 - remote directory
147    #
148    fetchurl() {
149        getter=$1 ; shift
150        echo $this: Fetching $1 from $3. Please stand by...
151        fetched=no
152        for base in $2 $VERSION-$2 ; do
153            for ext in tar.gz tgz tar.Z tz tar tar.bz2 ; do
154                try=$base.$ext
155                echo $this: Trying $try ...
156                if $getter $3 $try $ROOT/$try ; then
157                    fetched=yes
158                    echo $this: Fetching $try was a success.
159                    break 2         # get out of both for-loops
160                else
161                    rm -f $ROOT/$try
162          fi          fi
163            done
164        done
165        if [ $fetched = no ] ; then
166            echo $this: Fetching $try was no success.
167            echo '  ' You should try to do it manually now.
168            askurl "$1" "$2" "$3"
169        fi
170    }
171    
172    usewget() {
173        wget -nv -O $3 $1/$2
174    }
175    
176    uselynx() {
177        lynx -source $1/$2 >$3
178    }
179    
180    testurlgetter() {
181        (exec >/dev/null 2>&1 ; exec $*)
182    }
183    
184    #
185    # Function to check whether wget or lynx is available.
186    # Set URLGETTER accordingly.
187    #
188    urlgetter() {
189        if [ "$URLGETTER" = unknown ] ; then
190            if testurlgetter wget --help ; then
191                URLGETTER="fetchurl usewget"
192            elif testurlgetter lynx -help ; then
193                URLGETTER="fetchurl uselynx"
194            else
195                URLGETTER="askurl"
196            fi
197        fi
198    }
199    
200    un_tar() {
201        echo "$this: Un-TAR-ing $1 archive."
202        tar -xf $2
203    }
204    
205    un_tar_Z() {
206        echo "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
207        zcat $2 | tar -xf -
208    }
209    
210    un_tar_gz() {
211        echo "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
212        gunzip -c $2 | tar -xf -
213    }
214    
215    un_tar_bz2() {
216        echo "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
217        bunzip2 -c $2 | tar -xf -
218    }
219    
220    unarchive() {
221        # $1: descriptive string, $2: archive, $3: unpacker
222        if [ -r $ROOT/$2 ] ; then
223            $3 "$1" $ROOT/$2
224        elif [ -r $ROOT/$VERSION-$2 ]; then
225            $3 "$1" $ROOT/$VERSION-$2
226        else
227            return 1
228      fi      fi
229  }  }
230    
# Line 100  Line 237 
237  # $4: the basename of the source archive (the script will check several  # $4: the basename of the source archive (the script will check several
238  #     different suffixes to determine what kind of de-compression is to  #     different suffixes to determine what kind of de-compression is to
239  #     be used)  #     be used)
240    #
241    # fetch_n_unpack is the helper function that does the real work.  If
242    # no archive is found locally, it invokes $URLGETTER and tries again.
243    # The variable $tryfetch is used to make sure this happens only once.
244    fetch_n_unpack() {
245        cd $2
246        if unarchive "$1" $4.tar.gz un_tar_gz ||
247           unarchive "$1" $4.tgz un_tar_gz ||
248           unarchive "$1" $4.tar.Z un_tar_Z ||
249           unarchive "$1" $4.tar un_tar ||
250           unarchive "$1" $4.tar.bz1 un_tar_bz2 ||
251           unarchive "$1" $4.tz un_tar_Z
252        then
253            : we are done
254        elif [ $tryfetch = yes ] ; then
255            urlgetter
256            $URLGETTER "$1" $4 $SRCARCHIVEURL
257            tryfetch=no
258            fetch_n_unpack "$1" "$2" "$3" "$4"
259        fi
260    }
261    
262    #
263    # The main "unpack" driver function that invokes the above helper.
264    #
265  unpack() {  unpack() {
266        tryfetch=yes
267      if [ -d $2/$3 ]; then      if [ -d $2/$3 ]; then
268          echo "The $1 source tree already exists."          echo "$this: The $1 tree already exists."
269      else      else
270          echo "Unpacking $1 source archive."          fetch_n_unpack "$1" "$2" "$3" "$4"
         cd $2  
         if [ -r $4.tar.Z ] ; then  
             zcat $4.tar.Z | tar -xf -  
         elif [ -r $4.tar ] ; then  
             tar -xf $4.tar  
         elif [ -r $4.tar.gz ] ; then  
             gunzip -c $4.tar.gz | tar -xf -  
         elif [ -r $4.tar.bz2 ] ; then  
             bunzip2 -c $4.tar.bz2 | tar -xf -  
         elif [ -r $4.tgz ] ; then  
             gunzip -c $4.tgz | tar -xf -  
         elif [ -r $4.tz ] ; then  
             zcat $4.tz | tar -xf -  
         else  
             echo "!!! The $1 source archive is missing."  
             exit 1  
271          fi          fi
272          if [ ! -d $2/$3 ]; then          if [ ! -d $2/$3 ]; then
273              echo "!!! Unable to unpack $1 source archive."          echo "$this: !!! Unable to unpack $1 archive."
274              exit 1              exit 1
275          fi          fi
276    }
277    
278    # A function to move all stable library files to a parallel directory
279    # hierarchy.
280    # The first argument must be a simple path (no / inside), and
281    # the second argument must be an absolute path.
282    move() {
283        if [ -d $1 ] ; then
284            if [ ! -d $2 ] ; then
285                if [ -f $2 ] ; then
286                    echo $this: $2 exists as a non-directory.
287                    exit 1
288                fi
289                mkdir $2
290            fi
291            cd $1
292            for i in * ; do
293                move $i $2/$i
294            done
295            cd ..
296        elif [ -f $1 ] ; then
297            rm -f $2
298            mv $1 $2
299      fi      fi
300  }  }
301    
# Line 145  Line 315 
315          case $lib in          case $lib in
316          *.cm | *.cmi)          *.cm | *.cmi)
317              if [ $lib != $2 ] ; then              if [ $lib != $2 ] ; then
318                  echo "! Warning:" $lib specified relative to $2                  echo "$this: Warning:" $lib specified relative to $2
319              fi              fi
320              echo Moving library $lib to $LIBDIR              echo $this: Moving library $lib to $LIBDIR
321              makedir $LIBDIR/$2              makedir $LIBDIR/$2
322              makedir $LIBDIR/$2/CM              makedir $LIBDIR/$2/CM
323              makedir $LIBDIR/$2/CM/$ARCH-unix              makedir $LIBDIR/$2/CM/$ARCH-unix
# Line 173  Line 343 
343  reglib() {  reglib() {
344      if [ x$MOVE_LIBRARIES = xtrue ] ; then      if [ x$MOVE_LIBRARIES = xtrue ] ; then
345          FINALLOCATION=$LIBDIR/$1          FINALLOCATION=$LIBDIR/$1
346            FINALCONFIGPATH=$1
347      else      else
348          FINALLOCATION=$SRCDIR/$2          FINALLOCATION=$SRCDIR/$2
349            FINALCONFIGPATH=$FINALLOCATION
350      fi      fi
351      if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then      if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then
352          echo "Library $1 already exists in $FINALLOCATION."          echo "$this: Library $1 already exists in $FINALLOCATION."
353      else      else
354          echo "Scheduling library $1 to be built in $FINALLOCATION."          echo "$this: Scheduling library $1 to be built in $FINALLOCATION."
355          echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST          echo "  andalso CM.stabilize false \"\$/$1\"" >>$LIBLIST
356          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG
357          if [ x$MOVE_LIBRARIES = xtrue ] ; then          if [ x$MOVE_LIBRARIES = xtrue ] ; then
358              echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT              echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT
359          fi          fi
         echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT  
360      fi      fi
361        echo $1 $FINALCONFIGPATH >>$CM_PATHCONFIG_DEFAULT
362  }  }
363    
364  #  #
# Line 206  Line 378 
378          TARGETLOC=$TARGET          TARGETLOC=$TARGET
379      fi      fi
380      if [ -r $HEAPDIR/$TARGET ] ; then      if [ -r $HEAPDIR/$TARGET ] ; then
381          echo Target $TARGET already exists.          echo $this: Target $TARGET already exists.
382      else      else
383          echo Building $TARGET.          echo $this: Building $TARGET.
384          unpack $2 $SRCDIR $1 $ROOT/$VERSION-$1          unpack $2 $SRCDIR $1 $1
385          cd $SRCDIR/$1          cd $SRCDIR/$1
386          ./build          ./build
387          if [ -r $TARGETLOC ] ; then          if [ -r $TARGETLOC ] ; then
# Line 219  Line 391 
391                  ln -s .run-sml $1                  ln -s .run-sml $1
392              fi              fi
393          else          else
394              echo "!!! Build of $TARGET failed."              echo "$this: !!! Build of $TARGET failed."
395          fi          fi
396      fi      fi
397  }  }
# Line 227  Line 399 
399  #  #
400  # create the various sub directories  # create the various sub directories
401  #  #
402  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
 do  
403      makedir $dir      makedir $dir
404  done  done
405    
# Line 236  Line 407 
407  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
408  #  #
409  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
410      echo Script $BINDIR/.arch-n-opsys already exists.      echo $this: Script $BINDIR/.arch-n-opsys already exists.
411  else  else
412      cat $CONFIGDIR/_arch-n-opsys \      cat $CONFIGDIR/_arch-n-opsys \
413      | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
414      chmod 555 $BINDIR/.arch-n-opsys      chmod 555 $BINDIR/.arch-n-opsys
415      if [ ! -x $BINDIR/.arch-n-opsys ]; then      if [ ! -x $BINDIR/.arch-n-opsys ]; then
416          echo "!!! Installation of $BINDIR/.arch-n-opsys failed."          echo "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
417          exit 1          exit 1
418      fi      fi
419  fi  fi
420    
421  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
422  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
423      echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
424      echo "!!! You must patch this by hand and repeat the installation."      echo "$this: !!! You must patch this by hand and repeat the installation."
425      exit 2      exit 2
426  else  else
427      echo Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.      echo $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
428  fi  fi
429  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
430    
# Line 265  Line 436 
436  installdriver() {  installdriver() {
437      dsrc=$1      dsrc=$1
438      ddst=$2      ddst=$2
439      if [ -x $BINDIR/$ddst ]; then  # We install the driver unconditionally. (It would be better to test
440          echo Script $BINDIR/$ddst already exists.  # for an outdated driver script, but not all "test" commands understand
441      else  # the -nt comparison operator....)
442    #   if [ -x $BINDIR/$ddst ]; then
443    #       echo $this: Script $BINDIR/$ddst already exists.
444    #   else
445            rm -f $BINDIR/$ddst
446          cat $CONFIGDIR/$dsrc | \          cat $CONFIGDIR/$dsrc | \
447          sed -e "s,@SHELL@,$SHELL,g" \          sed -e "s,@SHELL@,$SHELL,g" \
448              -e "s,@BINDIR@,$BINDIR," \              -e "s,@BINDIR@,$BINDIR," \
# Line 275  Line 450 
450              > $BINDIR/$ddst              > $BINDIR/$ddst
451          chmod 555 $BINDIR/$ddst          chmod 555 $BINDIR/$ddst
452          if [ ! -x $BINDIR/$ddst ]; then          if [ ! -x $BINDIR/$ddst ]; then
453              echo "!!! Installation of $BINDIR/${ddst} failed."              echo "$this: !!! Installation of $BINDIR/${ddst} failed."
454              exit 1              exit 1
455          fi          fi
456      fi  #   fi
457  }  }
458    
459  installdriver _run-sml .run-sml  installdriver _run-sml .run-sml
460  installdriver _link-sml .link-sml  installdriver _link-sml .link-sml
461  installdriver _ml-build ml-build  installdriver _ml-build ml-build
462    installdriver _ml-makedepend ml-makedepend
463    
464  #  #
465  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
# Line 293  Line 469 
469          ALLOC=1M          ALLOC=1M
470          ;;          ;;
471      x86)      x86)
472            # The following is the _wrong_ value for many popular x86 chips
473            # (i.e., Celerons).  However, the optimal value for those is 32k,
474            # and such a small value is not enough for the runtime system's boot
475            # code.  Therefore, we use 256k here and re-set it to the proper
476            # value in .run-sml.
477          ALLOC=256k          ALLOC=256k
478          ;;          ;;
479      alpha32)      alpha32)
# Line 310  Line 491 
491      linux)      linux)
492          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
493          if [ "$?" != "0" ]; then          if [ "$?" != "0" ]; then
494              echo "!!! Problems checking for underscores in global names."              echo "$this: !!! Problems checking for underscores in asm names."
495              exit 1              exit 1
496          fi          fi
497          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
# Line 320  Line 501 
501  #  #
502  # the name of the bin files directory  # the name of the bin files directory
503  #  #
504  BOOT_FILES=sml.boot.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
505    BOOT_FILES=sml.$BOOT_ARCHIVE
 #  
 # files to be deleted after we are done...  
 #  
 tmpfiles=""  
 tmpfiles="$tmpfiles $ROOT/preloads.standard"  
 tmpfiles="$tmpfiles $ROOT/$LIBLIST"  
 tmpfiles="$tmpfiles $ROOT/$LOCALPATHCONFIG"  
 tmpfiles="$tmpfiles $ROOT/$LIBMOVESCRIPT"  
 #  
 # also remove the boot dir because it won't have anything interesting in  
 # it after we are successful...  
 #  
 tmpfiles="$tmpfiles $ROOT/$BOOT_FILES"  
 #  
 # make sure we always clean up after ourselves...  
 #  
 trap 'rm -rf $tmpfiles' 0 1 2 3 15  
506    
507  #  #
508  # build the run-time system  # build the run-time system
509  #  #
510  unpack "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime  unpack "run-time" $SRCDIR runtime runtime
511  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
512      echo Run-time system already exists.      echo $this: Run-time system already exists.
513  else  else
514      cd $SRCDIR/runtime/objs      cd $SRCDIR/runtime/objs
515      echo Compiling the run-time system.      echo $this: Compiling the run-time system.
516      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
517      if [ -x run.$ARCH-$OPSYS ]; then      if [ -x run.$ARCH-$OPSYS ]; then
518          mv run.$ARCH-$OPSYS $RUNDIR          mv run.$ARCH-$OPSYS $RUNDIR
519          # $MAKE MAKE=$MAKE clean          $MAKE MAKE=$MAKE clean
520      else      else
521          echo "!!! Run-time system build failed for some reason."          echo "$this: !!! Run-time system build failed for some reason."
522          exit 1          exit 1
523      fi      fi
524  fi  fi
# Line 364  Line 528 
528  # boot the base SML system  # boot the base SML system
529  #  #
530  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
531      echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      echo $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
532  else  else
533      unpack bin $ROOT $BOOT_FILES $ROOT/$VERSION-$BOOT_FILES      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
534      cd $ROOT/$BOOT_FILES      cd $ROOT/$BOOT_FILES
535      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
536      then      then
# Line 380  Line 544 
544              # the pathconfig file.              # the pathconfig file.
545              #              #
546              cd $ROOT/$BOOT_FILES              cd $ROOT/$BOOT_FILES
547              for lib in *.cm ; do              for anchor in * ; do
548                  echo $lib $LIBDIR/$lib >>$CM_PATHCONFIG_DEFAULT                  if [ -d $anchor ] ; then
549                  movelibs $ROOT/$BOOT_FILES/$lib $lib                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
550                        move $anchor $LIBDIR/$anchor
551                    fi
552              done              done
553              cd $ROOT              cd $ROOT
554              # rm -rf $BOOT_FILES              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
555                rm -rf $BOOT_FILES
556    
557          else          else
558              echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."              echo "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
559              exit 1              exit 1
560          fi          fi
561      else      else
562          echo "!!! Boot code failed, no heap image built (sml.$HEAP_SUFFIX)."          echo "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
563          exit 1          exit 1
564      fi      fi
565  fi  fi
# Line 402  Line 569 
569  #  #
570  cd $ROOT  cd $ROOT
571  rm -f $LOCALPATHCONFIG $LIBLIST  rm -f $LOCALPATHCONFIG $LIBLIST
572  echo 'OS.Process.exit (if true' >$LIBLIST  echo 'ignore (OS.Process.exit (if true' >$LIBLIST
573    
574  #  #
575  # now build (or prepare to build) the individual targets  # now build (or prepare to build) the individual targets
576  #  #
577  cd $SRCDIR  cd $SRCDIR
578  echo Installing other targets.  echo $this: Installing other targets.
579  for i in $TARGETS ; do  for i in $TARGETS ; do
580      case $i in      case $i in
581        src-smlnj)        src-smlnj)
582          for src in compiler cm MLRISC smlnj-lib ml-yacc system          for src in compiler cm MLRISC smlnj-lib ml-yacc system
583          do          do
584              unpack $src $ROOT/src $src $ROOT/$VERSION-$src              unpack $src $ROOT/src $src $src
585          done          done
586          ;;          ;;
587        ml-yacc)        ml-yacc)
# Line 429  Line 596 
596          standalone ml-burg ML-Burg          standalone ml-burg ML-Burg
597          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
598          ;;          ;;
599          ml-nlffigen)
600            echo standalone ml-nlffigen ML-NLFFI-Gen >>$LATESTANDALONES
601            echo ml-nlffigen $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
602            ;;
603        smlnj-lib)        smlnj-lib)
604          unpack "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
605    
606          # Don't make the Util library -- it came pre-made and has been          # Don't make the Util library -- it came pre-made and has been
607          # installed when making the base system.  In other words, don't do...          # installed when making the base system.  In other words, don't do...
# Line 449  Line 620 
620              reglib reactive-lib.cm smlnj-lib/Reactive              reglib reactive-lib.cm smlnj-lib/Reactive
621          ;;          ;;
622        cml)        cml)
623          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
624          reglib core-cml.cm cml/src/core-cml          reglib core-cml.cm cml/src/core-cml
625          reglib cml.cm cml/src          reglib cml.cm cml/src
626          reglib cml-basis.cm cml          reglib cml-basis.cm cml
627          ;;          ;;
628        cml-lib)        cml-lib)
629          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
630          reglib cml-lib.cm cml/cml-lib          reglib cml-lib.cm cml/cml-lib
631          ;;          ;;
632        eXene)        eXene)
633          unpack EXene $SRCDIR eXene $ROOT/$VERSION-eXene          unpack EXene $SRCDIR eXene eXene
634          reglib eXene.cm eXene          reglib eXene.cm eXene
635          ;;          ;;
636          ckit)
637            unpack "C-Kit" $ROOT ckit ckit
638            reglib ckit-lib.cm ../ckit/src
639            ;;
640          ml-nlffi-lib)
641            unpack "NLFFI Library" $SRCDIR ml-nlffi-lib ml-nlffi-lib
642            reglib memory.cm ml-nlffi-lib/memory
643            reglib c-int.cm ml-nlffi-lib/internals
644            reglib c.cm ml-nlffi-lib
645            ;;
646        doc)        doc)
647          unpack Doc $ROOT doc $ROOT/$VERSION-doc          unpack Doc $ROOT doc doc
648          cd $ROOT/doc          cd $ROOT/doc
649          build $ROOT          build $ROOT
650          ;;          ;;
651        *)        *)
652          echo "!!! Unknown target $i."          echo "$this: !!! Unknown target $i."
653          ;;          ;;
654      esac      esac
655  done  done
# Line 479  Line 660 
660  # $SRCDIR, so we must consult $LOCALPATHCONFIG.  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
661  #  #
662    
663  echo Compiling library code.  echo $this: Compiling library code.
664  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
665  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
666      echo Libraries compiled successfully.      echo $this: Libraries compiled successfully.
667  else  else
668      echo "!!! Something went wrong when compiling the libraries."      echo "$this: !!! Something went wrong when compiling the libraries."
669      exit 1      exit 1
670  fi  fi
671    
672  #  #
673  # Finally, move the libraries to their final locations...  # Move the libraries to their final locations...
674  #  #
675    
676  if [ -r $LIBMOVESCRIPT ] ; then  if [ -r $LIBMOVESCRIPT ] ; then
677      echo Moving libraries to $LIBDIR.      echo $this: Moving libraries to $LIBDIR.
678      . $LIBMOVESCRIPT      . $LIBMOVESCRIPT
679  fi  fi
680    
681    #
682    # Build "late" standalone programs (i.e., those that must be built
683    # after libraries are already in place):
684    #
685    
686    if [ -r $LATESTANDALONES ] ; then
687        echo $this: Building late standalone programs.
688        . $LATESTANDALONES
689    fi
690    
691    #
692    # Finally, remove duplicate entries from pathconfig file...
693    #
694    if [ -f $CM_PATHCONFIG_DEFAULT ] ; then
695        cp $CM_PATHCONFIG_DEFAULT $PCEDITTMP
696        rm -f $CM_PATHCONFIG_DEFAULT
697        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
698    NF != 2 { print $0 }
699    END { for (i in mapping) print i, mapping[i] }' \
700          | sort >$CM_PATHCONFIG_DEFAULT
701    fi
702    
703  exit 0  exit 0

Legend:
Removed from v.537  
changed lines
  Added in v.828

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0